//+------------------------------------------------------------------+
//|                                                        AMACD.mq4 |
//|                               Copyright  2012, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_separate_window

#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Green
#property indicator_color4 Red

extern int Short=12;
extern int Long=26;
extern int SignalLength=9;
extern int Price=0;    // Applied price
                       // 0 - Close
                       // 1 - Open
                       // 2 - High
                       // 3 - Low
                       // 4 - Median
                       // 5 - Typical
                       // 6 - Weighted  

double MACD[], Signal[], HistogramUp[], HistogramDn[];

int init()
  {
   IndicatorShortName("AMACD");
   IndicatorDigits(Digits);
   SetIndexBuffer(0,MACD);
   SetIndexBuffer(1,Signal);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2,HistogramUp);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(3,HistogramDn);

   return(0);
  }

int deinit()
  {

   return(0);
  }

double work[][1];
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
      int limit=MathMin(MathMax(Bars-counted_bars,MathMax(Short,Long)),Bars-1);
      ArrayResize(work,Bars);

      int pos=limit;
      for (i=limit, r=Bars-i-1; i>=0; i--,r++) work[r][0] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      for (i=limit, r=Bars-i-1; i>=0; i--,r++) MACD[i]=iCTma(0,Short,i)-iCTma(0,Long,i);
 
      pos=limit;
      double Hist;
      while (pos>=0)
      {
         Signal[pos]=iMAOnArray(MACD, 0, SignalLength, 0, MODE_SMA, pos);
         Hist=MACD[pos]-Signal[pos];
         if (Hist>=HistogramUp[pos+1]+HistogramDn[pos+1])
         {
               HistogramUp[pos]=Hist;
               HistogramDn[pos]=0;
         }
         else
         {
               HistogramUp[pos]=0;
               HistogramDn[pos]=Hist;
         }
         pos--;
      } 

 return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double iCTma(int useValue, int halfLength, int i)
{
   i = Bars-i-1;
   
   //
   //
   //
   //
   //
      
   double sum  = (halfLength+1)*work[i][useValue];
   double sumw = (halfLength+1);
 
      //
      //
      //
      //
      //
 
      int j,k = halfLength; 
      for(j=1; j<=halfLength; j++,k--)
      {
         if ((i-j)>=0)
         {
            sum  += k*work[i-j][useValue];
            sumw += k;
         }            
         if ((i+j)<Bars)
         {
            sum  += k*work[i+j][useValue];
            sumw += k;
         }            
      }
   return(sum/sumw);      
}

